// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2024 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from OutletGroup.idl.

package com.raritan.idl.pdumodel;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface OutletGroup_1_0_5 {
  static public final TypeInfo typeInfo = new TypeInfo("pdumodel.OutletGroup:1.0.5", null);

  public static final int ERR_INVALID_ARGUMENT = 1;

  static public class Sensors implements Cloneable {
    public com.raritan.idl.sensors.NumericSensor_4_0_4 activePower = null;
    public com.raritan.idl.sensors.AccumulatingNumericSensor_2_0_4 activeEnergy = null;

    public Object clone() {
      Sensors copy = new Sensors();

      copy.activePower = this.activePower;
      copy.activeEnergy = this.activeEnergy;

      return copy;
    }

  }

  static public class Settings implements Cloneable {
    public String name = new String();
    public java.util.List<com.raritan.idl.pdumodel.Outlet_2_1_9> members = new java.util.ArrayList<>();

    public Object clone() {
      Settings copy = new Settings();

      copy.name = this.name;
      copy.members = new java.util.ArrayList<com.raritan.idl.pdumodel.Outlet_2_1_9>(this.members);

      return copy;
    }

  }

  static public class MetaData implements Cloneable {
    public int groupId = 0;
    public int uniqueId = 0;

    public Object clone() {
      MetaData copy = new MetaData();

      copy.groupId = this.groupId;
      copy.uniqueId = this.uniqueId;

      return copy;
    }

  }

  public class SensorsChangedEvent extends com.raritan.idl.idl.Event {

    static public final TypeInfo typeInfo = new TypeInfo("pdumodel.OutletGroup_1_0_5.SensorsChangedEvent:1.0.0", com.raritan.idl.idl.Event.typeInfo);

    @Override
    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public com.raritan.idl.pdumodel.OutletGroup_1_0_5.Sensors oldSensors = new com.raritan.idl.pdumodel.OutletGroup_1_0_5.Sensors();
    public com.raritan.idl.pdumodel.OutletGroup_1_0_5.Sensors newSensors = new com.raritan.idl.pdumodel.OutletGroup_1_0_5.Sensors();
  }

  public class SettingsChangedEvent extends com.raritan.idl.event.UserEvent {

    static public final TypeInfo typeInfo = new TypeInfo("pdumodel.OutletGroup_1_0_5.SettingsChangedEvent:1.0.0", com.raritan.idl.event.UserEvent.typeInfo);

    @Override
    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public com.raritan.idl.pdumodel.OutletGroup_1_0_5.Settings oldSettings = new com.raritan.idl.pdumodel.OutletGroup_1_0_5.Settings();
    public com.raritan.idl.pdumodel.OutletGroup_1_0_5.Settings newSettings = new com.raritan.idl.pdumodel.OutletGroup_1_0_5.Settings();
  }

  public class PowerControlEvent extends com.raritan.idl.event.UserEvent {

    static public final TypeInfo typeInfo = new TypeInfo("pdumodel.OutletGroup_1_0_5.PowerControlEvent:1.0.0", com.raritan.idl.event.UserEvent.typeInfo);

    @Override
    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public com.raritan.idl.pdumodel.Outlet_2_1_9.PowerState state = com.raritan.idl.pdumodel.Outlet_2_1_9.PowerState.values()[0];
    public boolean cycle = false;
  }

  public class GetSensorsResult {
    public com.raritan.idl.pdumodel.OutletGroup_1_0_5.Sensors _ret_;
  }

  GetSensorsResult getSensors() throws Exception;

  AsyncRequest getSensors(AsyncRpcResponse<GetSensorsResult> rsp);

  AsyncRequest getSensors(AsyncRpcResponse<GetSensorsResult> rsp, RpcCtrl rpcCtrl);


  public class GetMetaDataResult {
    public com.raritan.idl.pdumodel.OutletGroup_1_0_5.MetaData _ret_;
  }

  GetMetaDataResult getMetaData() throws Exception;

  AsyncRequest getMetaData(AsyncRpcResponse<GetMetaDataResult> rsp);

  AsyncRequest getMetaData(AsyncRpcResponse<GetMetaDataResult> rsp, RpcCtrl rpcCtrl);


  public class GetSettingsResult {
    public com.raritan.idl.pdumodel.OutletGroup_1_0_5.Settings _ret_;
  }

  GetSettingsResult getSettings() throws Exception;

  AsyncRequest getSettings(AsyncRpcResponse<GetSettingsResult> rsp);

  AsyncRequest getSettings(AsyncRpcResponse<GetSettingsResult> rsp, RpcCtrl rpcCtrl);


  public class SetSettingsResult {
    public int _ret_;
  }

  SetSettingsResult setSettings(com.raritan.idl.pdumodel.OutletGroup_1_0_5.Settings settings) throws Exception;

  AsyncRequest setSettings(com.raritan.idl.pdumodel.OutletGroup_1_0_5.Settings settings, AsyncRpcResponse<SetSettingsResult> rsp);

  AsyncRequest setSettings(com.raritan.idl.pdumodel.OutletGroup_1_0_5.Settings settings, AsyncRpcResponse<SetSettingsResult> rsp, RpcCtrl rpcCtrl);


  public class SetAllOutletPowerStatesResult {
    public int _ret_;
  }

  SetAllOutletPowerStatesResult setAllOutletPowerStates(com.raritan.idl.pdumodel.Outlet_2_1_9.PowerState pstate) throws Exception;

  AsyncRequest setAllOutletPowerStates(com.raritan.idl.pdumodel.Outlet_2_1_9.PowerState pstate, AsyncRpcResponse<SetAllOutletPowerStatesResult> rsp);

  AsyncRequest setAllOutletPowerStates(com.raritan.idl.pdumodel.Outlet_2_1_9.PowerState pstate, AsyncRpcResponse<SetAllOutletPowerStatesResult> rsp, RpcCtrl rpcCtrl);


  public class CycleAllOutletPowerStatesResult {
    public int _ret_;
  }

  CycleAllOutletPowerStatesResult cycleAllOutletPowerStates() throws Exception;

  AsyncRequest cycleAllOutletPowerStates(AsyncRpcResponse<CycleAllOutletPowerStatesResult> rsp);

  AsyncRequest cycleAllOutletPowerStates(AsyncRpcResponse<CycleAllOutletPowerStatesResult> rsp, RpcCtrl rpcCtrl);

}
