// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2024 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from Port.idl.

package com.raritan.idl.portsmodel;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface Port {
  static public final TypeInfo typeInfo = new TypeInfo("portsmodel.Port:1.0.0", null);

  public static final int NO_ERROR = 0;

  public static final int ERR_INVALID_PARAM = 1;

  public enum Events {
    EVT_KEY_PROPS_CHANGED,
    EVT_KEY_DEVICE_CHANGED;
  }

  public enum DetectionType {
    AUTO,
    PINNED;
  }

  static public class DetectionMode implements Cloneable {
    public com.raritan.idl.portsmodel.Port.DetectionType type = com.raritan.idl.portsmodel.Port.DetectionType.values()[0];
    public String pinnedDeviceType = new String();

    public Object clone() {
      DetectionMode copy = new DetectionMode();

      copy.type = this.type;
      copy.pinnedDeviceType = this.pinnedDeviceType;

      return copy;
    }

  }

  static public class Properties implements Cloneable {
    public String name = new String();
    public String label = new String();
    public com.raritan.idl.portsmodel.Port.DetectionMode mode = new com.raritan.idl.portsmodel.Port.DetectionMode();
    public String detectedDeviceType = new String();
    public String detectedDeviceName = new String();

    public Object clone() {
      Properties copy = new Properties();

      copy.name = this.name;
      copy.label = this.label;
      Object modeCopy = this.mode.clone();
      copy.mode = (com.raritan.idl.portsmodel.Port.DetectionMode) modeCopy;
      copy.detectedDeviceType = this.detectedDeviceType;
      copy.detectedDeviceName = this.detectedDeviceName;

      return copy;
    }

  }

  public class GetPropertiesResult {
    public com.raritan.idl.portsmodel.Port.Properties _ret_;
  }

  GetPropertiesResult getProperties() throws Exception;

  AsyncRequest getProperties(AsyncRpcResponse<GetPropertiesResult> rsp);

  AsyncRequest getProperties(AsyncRpcResponse<GetPropertiesResult> rsp, RpcCtrl rpcCtrl);

  Void setName(String name) throws Exception;

  AsyncRequest setName(String name, AsyncRpcResponse<Void> rsp);

  AsyncRequest setName(String name, AsyncRpcResponse<Void> rsp, RpcCtrl rpcCtrl);


  public class SetDetectionModeResult {
    public int _ret_;
  }

  SetDetectionModeResult setDetectionMode(com.raritan.idl.portsmodel.Port.DetectionMode mode) throws Exception;

  AsyncRequest setDetectionMode(com.raritan.idl.portsmodel.Port.DetectionMode mode, AsyncRpcResponse<SetDetectionModeResult> rsp);

  AsyncRequest setDetectionMode(com.raritan.idl.portsmodel.Port.DetectionMode mode, AsyncRpcResponse<SetDetectionModeResult> rsp, RpcCtrl rpcCtrl);


  public class GetDetectableDevicesResult {
    public java.util.List<String> _ret_;
  }

  GetDetectableDevicesResult getDetectableDevices() throws Exception;

  AsyncRequest getDetectableDevices(AsyncRpcResponse<GetDetectableDevicesResult> rsp);

  AsyncRequest getDetectableDevices(AsyncRpcResponse<GetDetectableDevicesResult> rsp, RpcCtrl rpcCtrl);


  public class GetDeviceResult {
    public Object _ret_;
  }

  GetDeviceResult getDevice() throws Exception;

  AsyncRequest getDevice(AsyncRpcResponse<GetDeviceResult> rsp);

  AsyncRequest getDevice(AsyncRpcResponse<GetDeviceResult> rsp, RpcCtrl rpcCtrl);

}
