// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2024 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from Production.idl.

package com.raritan.json_rpc.production;

import org.json.*;

import com.raritan.idl.*;
import com.raritan.json_rpc.*;
import com.raritan.util.AsyncRequest;

public class Production_Proxy extends ObjectProxy implements com.raritan.idl.production.Production {

  public Production_Proxy(Agent agent, String rid, TypeInfo typeInfo) {
    super(agent, rid, typeInfo);
  }

  public Production_Proxy(Agent agent, String rid) {
    this(agent, rid, com.raritan.idl.production.Production.typeInfo);
  }

  public static Production_Proxy staticCast(ObjectProxy proxy) {
    return proxy == null ? null : new Production_Proxy(proxy.getAgent(), proxy.getRid(), proxy.getStaticTypeInfo());
  }


  @Override
  public EnterFactoryConfigModeResult enterFactoryConfigMode(final String password) throws Exception {
    JSONObject params = new JSONObject();
    params.put("password", password);
    final JSONObject result = rpcCall("enterFactoryConfigMode", params);
    EnterFactoryConfigModeResult ret = new EnterFactoryConfigModeResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest enterFactoryConfigMode(final String password, final AsyncRpcResponse<EnterFactoryConfigModeResult> rsp) {
    return enterFactoryConfigMode(password, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest enterFactoryConfigMode(final String password, final AsyncRpcResponse<EnterFactoryConfigModeResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("password", password);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("enterFactoryConfigMode", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          EnterFactoryConfigModeResult ret = new EnterFactoryConfigModeResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public Void leaveFactoryConfigMode() throws Exception {
    JSONObject params = null;
    rpcCall("leaveFactoryConfigMode", params);
    Void ret = null;
    return ret;
  }

  @Override
  public AsyncRequest leaveFactoryConfigMode(final AsyncRpcResponse<Void> rsp) {
    return leaveFactoryConfigMode(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest leaveFactoryConfigMode(final AsyncRpcResponse<Void> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("leaveFactoryConfigMode", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          Void ret = null;
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public IsFactoryConfigModeEnabledResult isFactoryConfigModeEnabled() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("isFactoryConfigModeEnabled", params);
    IsFactoryConfigModeEnabledResult ret = new IsFactoryConfigModeEnabledResult();
    ret._ret_ = result.getBoolean("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest isFactoryConfigModeEnabled(final AsyncRpcResponse<IsFactoryConfigModeEnabledResult> rsp) {
    return isFactoryConfigModeEnabled(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest isFactoryConfigModeEnabled(final AsyncRpcResponse<IsFactoryConfigModeEnabledResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("isFactoryConfigModeEnabled", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          IsFactoryConfigModeEnabledResult ret = new IsFactoryConfigModeEnabledResult();
          ret._ret_ = result.getBoolean("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }
}
