// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2024 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from StorageManager.idl.

package com.raritan.json_rpc.webcam;

import org.json.*;

import com.raritan.idl.*;
import com.raritan.json_rpc.*;
import com.raritan.util.AsyncRequest;

public class StorageManager_Proxy extends ObjectProxy implements com.raritan.idl.webcam.StorageManager {

  public StorageManager_Proxy(Agent agent, String rid, TypeInfo typeInfo) {
    super(agent, rid, typeInfo);
  }

  public StorageManager_Proxy(Agent agent, String rid) {
    this(agent, rid, com.raritan.idl.webcam.StorageManager.typeInfo);
  }

  public static StorageManager_Proxy staticCast(ObjectProxy proxy) {
    return proxy == null ? null : new StorageManager_Proxy(proxy.getAgent(), proxy.getRid(), proxy.getStaticTypeInfo());
  }


  @Override
  public GetSupportedStorageTypesResult getSupportedStorageTypes() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getSupportedStorageTypes", params);
    GetSupportedStorageTypesResult ret = new GetSupportedStorageTypesResult();
    ret._ret_ = new java.util.ArrayList<com.raritan.idl.webcam.StorageManager.StorageType>() {
      private static final long serialVersionUID = 1L;
      {
        final JSONArray array0 = result.getJSONArray("_ret_");
        for (int i0 = 0; i0 < array0.length(); i0++) {
          final int i0_f = i0;
          this.add(com.raritan.json_rpc.webcam.StorageManager.StorageType_Codec.decode(array0.getInt(i0_f)));
        }
      }
    };
    return ret;
  }

  @Override
  public AsyncRequest getSupportedStorageTypes(final AsyncRpcResponse<GetSupportedStorageTypesResult> rsp) {
    return getSupportedStorageTypes(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getSupportedStorageTypes(final AsyncRpcResponse<GetSupportedStorageTypesResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getSupportedStorageTypes", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetSupportedStorageTypesResult ret = new GetSupportedStorageTypesResult();
          ret._ret_ = new java.util.ArrayList<com.raritan.idl.webcam.StorageManager.StorageType>() {
            private static final long serialVersionUID = 1L;
            {
              final JSONArray array0 = result.getJSONArray("_ret_");
              for (int i0 = 0; i0 < array0.length(); i0++) {
                final int i0_f = i0;
                this.add(com.raritan.json_rpc.webcam.StorageManager.StorageType_Codec.decode(array0.getInt(i0_f)));
              }
            }
          };
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetInformationResult getInformation() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getInformation", params);
    GetInformationResult ret = new GetInformationResult();
    ret._ret_ = com.raritan.json_rpc.webcam.StorageManager.StorageInformation_Codec.decode(result.getJSONObject("_ret_"), agent);
    return ret;
  }

  @Override
  public AsyncRequest getInformation(final AsyncRpcResponse<GetInformationResult> rsp) {
    return getInformation(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getInformation(final AsyncRpcResponse<GetInformationResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getInformation", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetInformationResult ret = new GetInformationResult();
          ret._ret_ = com.raritan.json_rpc.webcam.StorageManager.StorageInformation_Codec.decode(result.getJSONObject("_ret_"), agent);
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetSettingsResult getSettings() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getSettings", params);
    GetSettingsResult ret = new GetSettingsResult();
    ret._ret_ = com.raritan.json_rpc.webcam.StorageManager.StorageSettings_Codec.decode(result.getJSONObject("_ret_"), agent);
    return ret;
  }

  @Override
  public AsyncRequest getSettings(final AsyncRpcResponse<GetSettingsResult> rsp) {
    return getSettings(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getSettings(final AsyncRpcResponse<GetSettingsResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getSettings", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetSettingsResult ret = new GetSettingsResult();
          ret._ret_ = com.raritan.json_rpc.webcam.StorageManager.StorageSettings_Codec.decode(result.getJSONObject("_ret_"), agent);
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public SetSettingsResult setSettings(final com.raritan.idl.webcam.StorageManager.StorageSettings settings) throws Exception {
    JSONObject params = new JSONObject();
    params.put("settings", com.raritan.json_rpc.webcam.StorageManager.StorageSettings_Codec.encode(settings));
    final JSONObject result = rpcCall("setSettings", params);
    SetSettingsResult ret = new SetSettingsResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest setSettings(final com.raritan.idl.webcam.StorageManager.StorageSettings settings, final AsyncRpcResponse<SetSettingsResult> rsp) {
    return setSettings(settings, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest setSettings(final com.raritan.idl.webcam.StorageManager.StorageSettings settings, final AsyncRpcResponse<SetSettingsResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("settings", com.raritan.json_rpc.webcam.StorageManager.StorageSettings_Codec.encode(settings));
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("setSettings", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          SetSettingsResult ret = new SetSettingsResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public AddImageResult addImage(final com.raritan.idl.webcam.Webcam_2_0_0 webcam, final com.raritan.idl.webcam.Image_2_0_0 image) throws Exception {
    JSONObject params = new JSONObject();
    params.put("webcam", webcam != null ? ((ObjectProxy) webcam).encode() : JSONObject.NULL);
    params.put("image", com.raritan.json_rpc.webcam.Image_2_0_0_Codec.encode(image));
    final JSONObject result = rpcCall("addImage", params);
    AddImageResult ret = new AddImageResult();
    ret._ret_ = result.getInt("_ret_");
    ret.index = result.getLong("index");
    return ret;
  }

  @Override
  public AsyncRequest addImage(final com.raritan.idl.webcam.Webcam_2_0_0 webcam, final com.raritan.idl.webcam.Image_2_0_0 image, final AsyncRpcResponse<AddImageResult> rsp) {
    return addImage(webcam, image, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest addImage(final com.raritan.idl.webcam.Webcam_2_0_0 webcam, final com.raritan.idl.webcam.Image_2_0_0 image, final AsyncRpcResponse<AddImageResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("webcam", webcam != null ? ((ObjectProxy) webcam).encode() : JSONObject.NULL);
      params.put("image", com.raritan.json_rpc.webcam.Image_2_0_0_Codec.encode(image));
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("addImage", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          AddImageResult ret = new AddImageResult();
          ret._ret_ = result.getInt("_ret_");
          ret.index = result.getLong("index");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public RemoveImagesResult removeImages(final com.raritan.idl.webcam.Webcam_2_0_0 webcam, final long start, final int count, final com.raritan.idl.webcam.StorageManager.Direction direction) throws Exception {
    JSONObject params = new JSONObject();
    params.put("webcam", webcam != null ? ((ObjectProxy) webcam).encode() : JSONObject.NULL);
    params.put("start", start);
    params.put("count", count);
    params.put("direction", com.raritan.json_rpc.webcam.StorageManager.Direction_Codec.encode(direction));
    final JSONObject result = rpcCall("removeImages", params);
    RemoveImagesResult ret = new RemoveImagesResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest removeImages(final com.raritan.idl.webcam.Webcam_2_0_0 webcam, final long start, final int count, final com.raritan.idl.webcam.StorageManager.Direction direction, final AsyncRpcResponse<RemoveImagesResult> rsp) {
    return removeImages(webcam, start, count, direction, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest removeImages(final com.raritan.idl.webcam.Webcam_2_0_0 webcam, final long start, final int count, final com.raritan.idl.webcam.StorageManager.Direction direction, final AsyncRpcResponse<RemoveImagesResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("webcam", webcam != null ? ((ObjectProxy) webcam).encode() : JSONObject.NULL);
      params.put("start", start);
      params.put("count", count);
      params.put("direction", com.raritan.json_rpc.webcam.StorageManager.Direction_Codec.encode(direction));
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("removeImages", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          RemoveImagesResult ret = new RemoveImagesResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetMetaDataResult getMetaData(final com.raritan.idl.webcam.Webcam_2_0_0 webcam, final long start, final int count, final com.raritan.idl.webcam.StorageManager.Direction direction) throws Exception {
    JSONObject params = new JSONObject();
    params.put("webcam", webcam != null ? ((ObjectProxy) webcam).encode() : JSONObject.NULL);
    params.put("start", start);
    params.put("count", count);
    params.put("direction", com.raritan.json_rpc.webcam.StorageManager.Direction_Codec.encode(direction));
    final JSONObject result = rpcCall("getMetaData", params);
    GetMetaDataResult ret = new GetMetaDataResult();
    ret._ret_ = result.getInt("_ret_");
    ret.meta = new java.util.ArrayList<com.raritan.idl.webcam.StorageManager.ImageStorageMetaData>() {
      private static final long serialVersionUID = 1L;
      {
        final JSONArray array0 = result.getJSONArray("meta");
        for (int i0 = 0; i0 < array0.length(); i0++) {
          final int i0_f = i0;
          this.add(com.raritan.json_rpc.webcam.StorageManager.ImageStorageMetaData_Codec.decode(array0.getJSONObject(i0_f), agent));
        }
      }
    };
    return ret;
  }

  @Override
  public AsyncRequest getMetaData(final com.raritan.idl.webcam.Webcam_2_0_0 webcam, final long start, final int count, final com.raritan.idl.webcam.StorageManager.Direction direction, final AsyncRpcResponse<GetMetaDataResult> rsp) {
    return getMetaData(webcam, start, count, direction, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getMetaData(final com.raritan.idl.webcam.Webcam_2_0_0 webcam, final long start, final int count, final com.raritan.idl.webcam.StorageManager.Direction direction, final AsyncRpcResponse<GetMetaDataResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("webcam", webcam != null ? ((ObjectProxy) webcam).encode() : JSONObject.NULL);
      params.put("start", start);
      params.put("count", count);
      params.put("direction", com.raritan.json_rpc.webcam.StorageManager.Direction_Codec.encode(direction));
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("getMetaData", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetMetaDataResult ret = new GetMetaDataResult();
          ret._ret_ = result.getInt("_ret_");
          ret.meta = new java.util.ArrayList<com.raritan.idl.webcam.StorageManager.ImageStorageMetaData>() {
            private static final long serialVersionUID = 1L;
            {
              final JSONArray array0 = result.getJSONArray("meta");
              for (int i0 = 0; i0 < array0.length(); i0++) {
                final int i0_f = i0;
                this.add(com.raritan.json_rpc.webcam.StorageManager.ImageStorageMetaData_Codec.decode(array0.getJSONObject(i0_f), agent));
              }
            }
          };
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetImagesResult getImages(final com.raritan.idl.webcam.Webcam_2_0_0 webcam, final long start, final int count, final com.raritan.idl.webcam.StorageManager.Direction direction) throws Exception {
    JSONObject params = new JSONObject();
    params.put("webcam", webcam != null ? ((ObjectProxy) webcam).encode() : JSONObject.NULL);
    params.put("start", start);
    params.put("count", count);
    params.put("direction", com.raritan.json_rpc.webcam.StorageManager.Direction_Codec.encode(direction));
    final JSONObject result = rpcCall("getImages", params);
    GetImagesResult ret = new GetImagesResult();
    ret._ret_ = result.getInt("_ret_");
    ret.image = new java.util.ArrayList<com.raritan.idl.webcam.StorageManager.StorageImage>() {
      private static final long serialVersionUID = 1L;
      {
        final JSONArray array0 = result.getJSONArray("image");
        for (int i0 = 0; i0 < array0.length(); i0++) {
          final int i0_f = i0;
          this.add(com.raritan.json_rpc.webcam.StorageManager.StorageImage_Codec.decode(array0.getJSONObject(i0_f), agent));
        }
      }
    };
    return ret;
  }

  @Override
  public AsyncRequest getImages(final com.raritan.idl.webcam.Webcam_2_0_0 webcam, final long start, final int count, final com.raritan.idl.webcam.StorageManager.Direction direction, final AsyncRpcResponse<GetImagesResult> rsp) {
    return getImages(webcam, start, count, direction, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getImages(final com.raritan.idl.webcam.Webcam_2_0_0 webcam, final long start, final int count, final com.raritan.idl.webcam.StorageManager.Direction direction, final AsyncRpcResponse<GetImagesResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("webcam", webcam != null ? ((ObjectProxy) webcam).encode() : JSONObject.NULL);
      params.put("start", start);
      params.put("count", count);
      params.put("direction", com.raritan.json_rpc.webcam.StorageManager.Direction_Codec.encode(direction));
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("getImages", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetImagesResult ret = new GetImagesResult();
          ret._ret_ = result.getInt("_ret_");
          ret.image = new java.util.ArrayList<com.raritan.idl.webcam.StorageManager.StorageImage>() {
            private static final long serialVersionUID = 1L;
            {
              final JSONArray array0 = result.getJSONArray("image");
              for (int i0 = 0; i0 < array0.length(); i0++) {
                final int i0_f = i0;
                this.add(com.raritan.json_rpc.webcam.StorageManager.StorageImage_Codec.decode(array0.getJSONObject(i0_f), agent));
              }
            }
          };
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetActivitiesResult getActivities() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getActivities", params);
    GetActivitiesResult ret = new GetActivitiesResult();
    ret._ret_ = new java.util.ArrayList<com.raritan.idl.webcam.StorageManager.Activity>() {
      private static final long serialVersionUID = 1L;
      {
        final JSONArray array0 = result.getJSONArray("_ret_");
        for (int i0 = 0; i0 < array0.length(); i0++) {
          final int i0_f = i0;
          this.add(com.raritan.json_rpc.webcam.StorageManager.Activity_Codec.decode(array0.getJSONObject(i0_f), agent));
        }
      }
    };
    return ret;
  }

  @Override
  public AsyncRequest getActivities(final AsyncRpcResponse<GetActivitiesResult> rsp) {
    return getActivities(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getActivities(final AsyncRpcResponse<GetActivitiesResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getActivities", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetActivitiesResult ret = new GetActivitiesResult();
          ret._ret_ = new java.util.ArrayList<com.raritan.idl.webcam.StorageManager.Activity>() {
            private static final long serialVersionUID = 1L;
            {
              final JSONArray array0 = result.getJSONArray("_ret_");
              for (int i0 = 0; i0 < array0.length(); i0++) {
                final int i0_f = i0;
                this.add(com.raritan.json_rpc.webcam.StorageManager.Activity_Codec.decode(array0.getJSONObject(i0_f), agent));
              }
            }
          };
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public StartActivityResult startActivity(final com.raritan.idl.webcam.Webcam_2_0_0 webcam, final int count, final int interval) throws Exception {
    JSONObject params = new JSONObject();
    params.put("webcam", webcam != null ? ((ObjectProxy) webcam).encode() : JSONObject.NULL);
    params.put("count", count);
    params.put("interval", interval);
    final JSONObject result = rpcCall("startActivity", params);
    StartActivityResult ret = new StartActivityResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest startActivity(final com.raritan.idl.webcam.Webcam_2_0_0 webcam, final int count, final int interval, final AsyncRpcResponse<StartActivityResult> rsp) {
    return startActivity(webcam, count, interval, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest startActivity(final com.raritan.idl.webcam.Webcam_2_0_0 webcam, final int count, final int interval, final AsyncRpcResponse<StartActivityResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("webcam", webcam != null ? ((ObjectProxy) webcam).encode() : JSONObject.NULL);
      params.put("count", count);
      params.put("interval", interval);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("startActivity", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          StartActivityResult ret = new StartActivityResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public StopActivityResult stopActivity(final com.raritan.idl.webcam.Webcam_2_0_0 webcam) throws Exception {
    JSONObject params = new JSONObject();
    params.put("webcam", webcam != null ? ((ObjectProxy) webcam).encode() : JSONObject.NULL);
    final JSONObject result = rpcCall("stopActivity", params);
    StopActivityResult ret = new StopActivityResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest stopActivity(final com.raritan.idl.webcam.Webcam_2_0_0 webcam, final AsyncRpcResponse<StopActivityResult> rsp) {
    return stopActivity(webcam, rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest stopActivity(final com.raritan.idl.webcam.Webcam_2_0_0 webcam, final AsyncRpcResponse<StopActivityResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = new JSONObject();
    try {
      params.put("webcam", webcam != null ? ((ObjectProxy) webcam).encode() : JSONObject.NULL);
    } catch (Exception e) {
      rsp.onFailure(e);
    }
    return rpcCall("stopActivity", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          StopActivityResult ret = new StopActivityResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }
}
